package com.github.bluesbruce.spring.service;

import com.alibaba.fastjson.JSONObject;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;

@Component
public class MqttLiveHandle {
    @Autowired
    private RtmpLiveService rtmpLiveService;

    public void handleLive(final String topic, MqttMessage message){
        String objmsg = new String(message.getPayload());
        final JSONObject jsonObject = JSONObject.parseObject(objmsg);
        if (!ObjectUtils.isEmpty(jsonObject.get("command"))){
            String cmdoperat = jsonObject.get("command").toString();
            if (cmdoperat.equals("start")){
                Thread thread = new Thread(new Runnable() {
                    String code= jsonObject.get("code")==null?topic.split("/")[2]:jsonObject.get("code").toString();
                    public void run() {
                        rtmpLiveService.pushServer(code);
                    }
                });
                thread.start();
            }else if (cmdoperat.equals("stop")){
                rtmpLiveService.stopRtmp();
            }
        }
    }


}
